#include <stdio.h>
#include <termio.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/timeb.h>
#include <fcntl.h>
#include <stdlib.h>
#include <unistd.h>
#include <signal.h>

extern int vpc_exit(int sig);

int f;

FILE	*inf;
char	*diskA;
int	sizeA;
char	nameA[256];
int	rd=0, wr=0;

//char *logo = "Welcome to Atari Linux workstation!\n";
//char *logo = "1234567890\n";

void raw( void )
{
struct termios it;

if (tcgetattr(f,&it)<0) err( "get attr" );
it.c_lflag &= 0; //~(ICANON|ISIG|ECHO);
it.c_iflag &= 0; // ~(INPCK|ISTRIP|IXON);
//it.c_iflag |= IGNPAR;
it.c_oflag &=0; // ~(OPOST);
it.c_cc[VMIN] = 1;
it.c_cc[VTIME] = 0;

if (cfsetospeed( &it, B19200 )<0) err( "set o speed" );
if (cfsetispeed( &it, B19200 )<0) err( "set i speed" );
if (tcsetattr(f,TCSANOW,&it)<0) err( "set attr" );
}

int main(int argc, char *argv[])
{
    char c;
    unsigned short ad;
    int i;
    
    unsigned char op, p1, p2;
    
    printf("Open COM2:\n");
    f = open("/dev/cua1", O_RDWR);
    if (!f) {
	printf("COM2: error!\n");
	exit(-1);
    } else printf(":\n");
    raw();

    diskA = (char *)malloc(512);

    strcpy(nameA, argv[1]);
    
    inf = fopen(argv[1], "r+");
//    sizeA = fread(diskA, 1, 2000000, inf);
//    fclose(inf);
    fseek(inf, 0, SEEK_END);
    printf("disk A: size %d\n", ftell(inf));
    
    signal(SIGTERM, (void *)vpc_exit);
    signal(SIGINT, (void *)vpc_exit);
        
    while(1){
	printf("send = %d bytes, recv = %d bytes\r", rd, wr); fflush(stdout);
	read(f, &c, 1);
//	printf("->%02x\n", c); fflush(stdout);

	switch(c) {
	    case 'I':
		printf("Initialization, Pyldin started! :)\n");
		break;
	    case 'R': {
		read(f, &p1, 1);
		read(f, &p2, 1);
		int p = (p1<<8)+p2;
		int s=0;
		fseek(inf, p*512, SEEK_SET);
		fread(diskA, 1, 512, inf);
		for (int qi = 0; qi < 512; qi++) {
		    write(f, diskA+qi, 1);
		}
		p=p+s;
		rd+=512;
		break;
		}
	    case 'W': {
		read(f, &p1, 1);
		read(f, &p2, 1);
		int p = (p1<<8)+p2;
		for (int qi = 0; qi < 512; qi++) {
		    read(f, diskA+qi, 1);
		}
		fseek(inf, p*512, SEEK_SET);
		fwrite(diskA, 1, 512, inf);
		wr+=512;
		break;
		}		
	}

//        read(f, &op, 1);
//        read(f, &p1, 1);
//        read(f, &p2, 1);
//	ad = (p1<<8)|p2;
//        printf("%02x = %04x\n", c, ad);
    }
}

int vpc_exit(int sig)
{
//    if (wr) printf("\nstore disk image ...%s\n\n", nameA);
//    inf = fopen(nameA, "wb");
//    fwrite(diskA, 1, sizeA, inf);
    fclose(inf);
    exit(0);
}
